=== debian/changelog ===
nifticlib (3.0.1-9) unstable; urgency=medium

  * Team upload.
  * Add autopkgtests
  * Install examples
  * Bump Standards-Version to 4.6.1 (no changes needed)
  * Add copyright for test data

 -- Mohammed Bilal <mdbilal@disroot.org>  Tue, 31 May 2022 21:58:14 +0530

nifticlib (3.0.1-8) unstable; urgency=medium

  * Team upload.

  [ Juhani Numminen ]
  * Change Depends, Breaks, Provides, Conflicts and Replaces.
    - Remove references to libnifti0-dev, libnifti1-dev, libfslio-dev and
      libniftiio-dev (<= 3.0). They are not packages in any recent Debian
      release. Detected using 'cme check dpkg'.
    - libznz3, libnifti2-2: remove Breaks/Replaces against libnifti2
      (completely new sonames, no file conflicts).
    - libnifti2-2: Remove Provides: libnifti2. It cannot claim to provide the
      multiple libraries that libnifti2 has.
    - libnifticdf-dev: Remove erroneous Conflicts against libniftiio-dev.
    - libnifti2-dev, libniftiio-dev, libnifticdf-dev, libznz-dev:
      Add Breaks+Replaces libnifti-dev (<= 3.0) due to overwriting files.
    - libniftiio2, libnifticdf2:
      Add Breaks+Replaces libnifti2 (<= 3.0) due to having same sonames.
    - libnifti2-dev: Add Depends: libnifticdf-dev which was omitted.
    - libnifti2-dev: Make virtual provided libnifti-dev versioned
      (see: #978236).
  * Put transitional libnifti-dev in Section: oldlibs and nifti-bin in science.
  * d/rules: Change direct cmake to dh_auto_configure. This fixes handling of
    CPPFLAGS. Removed reference to -Wl,--as-needed, it is on by default.

  [ Michael R. Crusoe ]
  * Remove no-longer needed patches.
  * debian/control: apply the advice of the multi-arch hinter

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 02 Jan 2021 16:36:29 +0100

nifticlib (3.0.1-7) unstable; urgency=medium

  * Team upload.
  * d/control libnifti2-2 provides versioned libnifti2 (= 3.0.1)

 -- Antoni Villalonga <antoni@friki.cat>  Thu, 31 Dec 2020 03:42:09 +0100

nifticlib (3.0.1-6) unstable; urgency=medium

  * Team upload.
  * Source-only upload.

 -- Andreas Tille <tille@debian.org>  Fri, 25 Dec 2020 15:07:16 +0100

nifticlib (3.0.1-5) unstable; urgency=medium

  * Team upload.
  * Provide transitional package libnifti-dev to enable smooth migration.

 -- Andreas Tille <tille@debian.org>  Fri, 25 Dec 2020 14:32:51 +0100

nifticlib (3.0.1-4) unstable; urgency=medium

  * Remove remaining illegal Provides: libnifti-dev
  * Fix Provides for shared lib

 -- Andreas Tille <tille@debian.org>  Mon, 07 Dec 2020 16:09:58 +0100

nifticlib (3.0.1-3) unstable; urgency=medium

  * Team upload
  * libnifti2-dev: Depends: libniftiio-dev, libznz-dev
    (addresses reopened #968730)
  * Make sure devel packages are installing properly

 -- Andreas Tille <tille@debian.org>  Mon, 07 Dec 2020 15:10:57 +0100

nifticlib (3.0.1-2) unstable; urgency=medium

  * Team upload.
  * Source only upload

 -- Andreas Tille <tille@debian.org>  Fri, 04 Dec 2020 23:48:56 +0100

nifticlib (3.0.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
    Closes: #968730
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Make source package Section: science
  * Separate binary packages for libznz, libniftiio, libnifticdf

 -- Andreas Tille <tille@debian.org>  Tue, 01 Dec 2020 22:17:54 +0100
