=== debian/control ===
Source: nifticlib
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael Hanke <mih@debian.org>,
           Yaroslav Halchenko <debian@onerussian.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               d-shlibs,
               cmake,
               zlib1g-dev,
               doxygen,
               python3,
               graphviz
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/nifticlib
Vcs-Git: https://salsa.debian.org/med-team/nifticlib.git
Homepage: https://github.com/NIFTI-Imaging/nifti_clib
Rules-Requires-Root: no

Package: libnifti2-2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: IO libraries for the NIfTI-1 data format
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package contains the shared library of libnifti.

Package: libnifti2-dev
Architecture: any
Section: libdevel
Depends: libnifti2-2 (= ${binary:Version}),
         libnifticdf-dev (= ${binary:Version}),
         libniftiio-dev (= ${binary:Version}),
         libznz-dev (= ${binary:Version}),
         ${misc:Depends}
Breaks: libnifti-dev (<= 3.0)
Provides: libnifti-dev (= ${binary:Version})
Replaces: libnifti-dev (<= 3.0)
Description: IO libraries for the NIfTI-1 data format (development)
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package provides the header files and static libraries of libnifti2.

Package: libnifti-dev
Architecture: all
Section: oldlibs
Depends: libnifti2-dev,
         ${misc:Depends}
Description: IO libraries for the NIfTI-1 data format (obsolete)
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This is a transitional dummy package.  It installs libnifti2-dev which
 should be used instead.

Package: libniftiio2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libnifti2 (<= 3.0)
Replaces: libnifti2 (<= 3.0)
Description: low-level IO libraries for the NIfTI-1 data format (niftiio)
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package contains the shared library of the low-level IO library niftiio.

Package: libniftiio-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libniftiio2 (= ${binary:Version}),
         ${misc:Depends}
Breaks: libnifti-dev (<= 3.0)
Replaces: libnifti-dev (<= 3.0)
Description: development low-level IO libraries for the NIfTI-1 data format (niftiio)
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package provides the header files and static libraries of libniftiio.

Package: libnifticdf2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libnifti2 (<= 3.0)
Replaces: libnifti2 (<= 3.0)
Description: NIfTI functions to compute cumulative distributions
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package contains the shared library nifticdf that provides functions
 to compute cumulative distributions and their inverses.

Package: libnifticdf-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libnifticdf2 (= ${binary:Version}),
         ${misc:Depends}
Breaks: libnifti-dev (<= 3.0)
Replaces: libnifti-dev (<= 3.0)
Description: NIfTI functions to compute cumulative distributions (development)
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package contains the header files and static libraries nifticdf that
 provides functions to compute cumulative distributions and their inverses.

Package: libznz3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: low-level IO library znzlib for the NIfTI-1 data format
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package contains the shared library low-level IO library znzlib.

Package: libznz-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libznz3 (= ${binary:Version}),
         ${misc:Depends}
Breaks: libnifti-dev (<= 3.0)
Replaces: libnifti-dev (<= 3.0)
Description: low-level IO library znzlib for the NIfTI-1 data format
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package provides the header files and static libraries of znzlib.

Package: nifti-bin
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: tools shipped with the NIfTI library
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package provides the tools that are shipped with the library
 (nifti_tool, nifti_stats and nifti1_test).

Package: libnifti-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         libjs-jquery
Description: NIfTI library API documentation
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package provides the library API reference documentation.
